/*
Storybook: Scene-based software for novelists and authors.
Copyright (C) 2008 - 2011 Martin Mustun

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package storybook.tools.swing.undo;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;

@SuppressWarnings("serial")
public class UndoAction extends AbstractAction {

	private SbUndoManager undo;

	public UndoAction(SbUndoManager undo) {
		super("Undo");
		this.undo = undo;
	}

	@Override
	public void actionPerformed(ActionEvent evt) {
		if (undo.canUndo()) {
			undo.undo();
			undo.endGroup();
		}
	}
}
